# mingw
ifeq ($(ARCH),w32)
	ARCH = nt32
else ifeq ($(ARCH),w64)
	ARCH = nt64
endif

# process
src/process/%.lo: $(SOURCE_DIR)/src/process/$(ARCH)/%.s $(ALL_HEADERS) host.tag tree.tag
		$(CC) -c -o $@ $<

src/process/%.o: $(SOURCE_DIR)/src/process/$(ARCH)/%.s $(ALL_HEADERS) host.tag tree.tag
		$(CC) -c -o $@ $<

# seh
src/seh/%.lo: $(SOURCE_DIR)/src/seh/$(ARCH)/%.s $(ALL_HEADERS) host.tag tree.tag
		$(CC) -c -o $@ $< $(CFLAGS_SHARED)

src/seh/%.o: $(SOURCE_DIR)/src/seh/$(ARCH)/%.s $(ALL_HEADERS) host.tag tree.tag
		$(CC) -c -o $@ $< $(CFLAGS_STATIC)

shared-objs-asm: src/process/tt_fork_v1.lo
shared-objs-asm: src/seh/ntapi_tt_seh_frame.lo

static-objs-asm: src/process/tt_fork_v1.o
static-objs-asm: src/seh/ntapi_tt_seh_frame.o
